/************************************************************************************
beego RT-Component
Copyright (c) 2010, Kyoto Uni.
All rights reserved.

Contact us if you use this software for sell.
If you use this software not for sell, you can use this software under BSD lisence.
See the files LICENSE.TXT and LICENSE-BSD.TXT for more details.                     
************************************************************************************/

/*---------------------------------------------------------------------------------*/
/*!
    @file mybeego.h
    @brief header for vxvtools
*/
/*---------------------------------------------------------------------------------*/
//to use simulator, define the following line.
//#define USE_SIMULATOR
#ifdef WIN32
#ifdef USE_SIMULATOR//for simulator
	#pragma comment(lib, "SDL.lib")
	#pragma comment(lib, "SDLmain.lib")
	#pragma comment(lib, "SDL_net.lib")
	#pragma comment(lib, "SDL_ttf.lib")
	#pragma comment(lib, "vxv2_monitor.lib")
#else//for real robot
	#pragma comment(lib, "vxv2.lib")
#endif
#endif

#ifdef USE_SIMULATOR//for simulator
	#include <mRunCtrl.h>
	#include <mURGCtrl.h>
	#include "vutils.h"

#else
	#include <runCtrl.h>
	//#include "URGCtrl.h"
	#include "pathUtils.h"
	#include "vutils.h"
#endif
using namespace VXV;


/*!
   @brief apply velocity input
   @param run VXV2 object
   @param straight traslational velocity[m/sec]
   @param Direction rotational velocity[rad/sec]
   @retval void
*/
static void setVelocityCtrl(RunCtrl& run,int straight, const Direction& rotate)
{
  enum { RIGHT = 0, LEFT = 1 };  
  int whl_mm_vel[2];
  int rotate_mm_vel = static_cast<int>(BODY_TREAD_MM/2 * rotate.to_rad());
  whl_mm_vel[RIGHT] = straight + rotate_mm_vel;
  whl_mm_vel[LEFT] = straight - rotate_mm_vel;

  for (int i = 0; i < 2; ++i) 
  {
    run.setWheelVel(i, whl_mm_vel[i]);
  }
}

